apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  name: emailworkers.code.dev
  annotations:
    controller-gen.kubebuilder.io/version: v0.16.0
spec:
  group: code.dev
  names:
    kind: EmailWorker
    listKind: EmailWorkerList
    plural: emailworkers
    singular: emailworker
    shortNames:
      - ew
  scope: Namespaced
  versions:
    - name: v1
      served: true
      storage: true
      subresources:
        status: {}
      additionalPrinterColumns:
        - name: Age
          jsonPath: .metadata.creationTimestamp
          type: date
      schema:
        openAPIV3Schema:
          type: object
          required: [spec]
          properties:
            apiVersion:
              type: string
            kind:
              type: string
            metadata:
              type: object
            spec:
              type: object
              required: []
              properties:
                image:
                  type: string
                  default: myapp/email-worker:latest
                env:
                  type: array
                  items:
                    type: object
                    required: [name]
                    properties:
                      name:
                        type: string
                      value:
                        type: string
                      valueFrom:
                        type: object
                        properties:
                          secretRef:
                            type: object
                            required: [name, secretName, secretKey]
                            properties:
                              name:
                                type: string
                              secretName:
                                type: string
                              secretKey:
                                type: string
                resources:
                  type: object
                  properties:
                    requests:
                      type: object
                      properties:
                        cpu:
                          type: string
                        memory:
                          type: string
                    limits:
                      type: object
                      properties:
                        cpu:
                          type: string
                        memory:
                          type: string
                imagePullPolicy:
                  type: string
                  default: IfNotPresent
            status:
              type: object
              properties:
                readyReplicas:
                  type: integer
                phase:
                  type: string
